'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AnySQLMySQL = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _mysqlAsPromised = require('mysql-as-promised');

var _mysqlAsPromised2 = _interopRequireDefault(_mysqlAsPromised);

var _sleepPromise = require('sleep-promise');

var _sleepPromise2 = _interopRequireDefault(_sleepPromise);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var AnySQLMySQL = exports.AnySQLMySQL = function () {
  function AnySQLMySQL(url) {
    _classCallCheck(this, AnySQLMySQL);

    this.pool = _mysqlAsPromised2.default.createPool(url);
    this.pool.on('connection', function (connection) {
      var sql = 'SET SESSION TRANSACTION ISOLATION LEVEL SERIALIZABLE';
      connection.query(sql);
    });
  }

  _createClass(AnySQLMySQL, [{
    key: 'query',
    value: function query(sql, values) {
      return this.pool.query(sql, values);
    }
  }, {
    key: 'transaction',
    value: function () {
      var ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(fn) {
        var connection, retries, result;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.pool.getConnection();

              case 2:
                connection = _context.sent;
                _context.prev = 3;
                retries = 0;

              case 5:
                if (!(retries < 30)) {
                  _context.next = 29;
                  break;
                }

                _context.next = 8;
                return connection.query('START TRANSACTION');

              case 8:
                _context.prev = 8;
                _context.next = 11;
                return fn({
                  query: function query(sql, values) {
                    return connection.query(sql, values);
                  },
                  transaction: function transaction(fn) {
                    return fn(this);
                  }
                });

              case 11:
                result = _context.sent;
                _context.next = 14;
                return connection.query('COMMIT');

              case 14:
                return _context.abrupt('return', result);

              case 17:
                _context.prev = 17;
                _context.t0 = _context['catch'](8);
                _context.next = 21;
                return connection.query('ROLLBACK');

              case 21:
                if (!(_context.t0.errno === 1205 || _context.t0.errno === 1213)) {
                  _context.next = 26;
                  break;
                }

                retries++;
                _context.next = 25;
                return (0, _sleepPromise2.default)(100);

              case 25:
                return _context.abrupt('continue', 5);

              case 26:
                throw _context.t0;

              case 27:
                _context.next = 5;
                break;

              case 29:
                throw new Error('Too many transaction retries');

              case 30:
                _context.prev = 30;

                connection.release();
                return _context.finish(30);

              case 33:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[3,, 30, 33], [8, 17]]);
      }));

      function transaction(_x) {
        return ref.apply(this, arguments);
      }

      return transaction;
    }()
  }, {
    key: 'close',
    value: function close() {
      return this.pool.end();
    }
  }]);

  return AnySQLMySQL;
}();

AnySQLMySQL.supportTruncatedKey = true;
AnySQLMySQL.tableCreationOptions = 'ENGINE=InnoDB DEFAULT CHARSET=utf8';
exports.default = AnySQLMySQL;